// A constant that determines how fast embers accelerate
// downward.
float gravity = 0.3;

// A class to represent a single ember in a firework.
class Ember
{
  // Position
  float x;
  float y;
  // Velocity
  float vx;
  float vy;
  // We only need to remember the hue component of
  // the colour (we'll max out the saturation and
  // brightness).
  float hue;

  // Create a new ember at the passed-in position, 
  // pointing in a random direction, with a random
  // speed between 0 and the passed-in max, and
  // a random hue in a narrow range around the passed-in
  // hue.
  Ember( float x, float y, float max_vel, float hue )
  {
    float ang = random( 0, TWO_PI );
    float vel = random( 0, max_vel );
    this.x = x;
    this.y = y;
    vx = vel * cos( ang );
    vy = vel * sin( ang );
    this.hue = hue + random( -5, 5 );
  }

  // Perform the physical simulation for a single ember.
  void step()
  {}

  // Have this ember draw itself.
  void draw()
  {
    noStroke();
    fill( hue, 255, 255 );
    ellipse( x, y, 5, 5 );
  }
}