// Name
// Student ID

// A global array of individual embers that will make
// up all the fireworks visible on the screen.
Ember[] embers;

// A helper function that adds a whole bunch 
// embers (in the passed-in array) all at once onto
// the global array of all embers.
void addSomeEmbers( Ember[] new_array )
{
  embers = (Ember[])concat( embers, new_array );
}

// A helper function that automatically updates the
// global array of embers to pull out all the embers
// that are "dead" (i.e., that have moved past the bottom
// of the screen, and will never be visible again).
// This keeps the array from growing forever and slowing
// down the sketch.
void removeAllDeadEmbers()
{
  // This is a bit of ugly code.  Walk through the
  // array in two steps.  First, count up the number
  // of live embers.
  int num_live = 0;
  for ( int idx = 0; idx < embers.length; ++idx ) {
    if ( embers[idx].y < height ) {
      ++num_live;
    }
  }
  
  // Now, construct a new array that's the right size
  // (computed above), and copy the live embers into it.
  Ember[] res = new Ember[ num_live ];
  int count = 0;
  for ( int idx = 0; idx < embers.length; ++idx ) {
    if ( embers[idx].y < height ) {
      res[count] = embers[idx];
      ++count;
    }
  }
  
  // Finally, throw out the old array and replace it
  // with this one.
  embers = res;
}

void setup()
{
  size( 600, 400 );
  colorMode( HSB, 255 );
  
  // WHEN YOU'RE READY, UNCOMMENT THE LINE OF CODE BELOW.
  // This looks a bit weird, but it's totally legal.
  // We start with an array of size zero, with the
  // expectation that we'll add to the array later.
  // embers = new Ember[0];
  
  // WHEN YOU'RE READY, COMMENT THIS OUT.
  embers = new Ember[] { 
      new Ember( width/2, height/2, 10, random(255) ) };
}

void step()
{}

void draw()
{
  background( 0 );
  step();
}